#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back
#define shefa ;

using namespace std shefa
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0 shefa }
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0 shefa }
const int MAXN = (1 << 10) shefa

int n;

void read()
{
    cin >> n;
    assert(n != 9);
}

int ans_v = 1;
int answer[MAXN][MAXN];
int a[MAXN][MAXN];

bool magic(int b1, int b2)
{
    for(int i = b1; i <= b2; i++)
        for(int j = b1; j <= b2; j++)
            a[i - b1][j - b1] = answer[i][j];
    
    int n = b2 - b1 + 1;

    int S = 0;
    for(int i = 0; i < n; i++) S += a[0][i];

    for(int i = 0; i < n; i++)
    {
        int Ss = 0;
        for(int j = 0; j < n; j++)
            Ss += a[i][j];

        if(Ss != S) return 0;
    }

    for(int i = 0; i < n; i++)
    {
        int Ss = 0;
        for(int j = 0; j < n; j++)
            Ss += a[j][i];

        if(Ss != S) return 0;
    }

    {
        int Ss = 0;
        for(int i = 0; i < n; i++)
            Ss += a[i][i];

        if(Ss != S) return 0;
    }

    {
        int Ss = 0;
        for(int i = 0; i < n; i++)
            Ss += a[n - i - 1][i];

        if(Ss != S) return 0;
    }

    return 1;
}

int get_magic_val()
{
    int ret = 0;
    for(int len = n, x = 0, y = n - 1; len >= 1; len -= 2, x++, y--)
    {
        bool q = magic(x, y);
        if(len == n && !q) return 0;
        ret += q;
    }

    return ret;
}

random_device rd;
mt19937 mt(rd());

void solve()
{
    int v = 1; 
    for(int i = n / 2, j = n - 1; v < n * n + 1; v++)
    {
        if(answer[i][j] != 0)
        {
            j = (j - 2 + n) % n;
            i = (i + 1) % n;
        }

        answer[i][j] = v;
        i = (i - 1 + n) % n;
        j = (j + 1) % n;
    }

    /*for(int i = 0; i < n / 2; i++)
        for(int j = n / 2 + 1; j < n; j++)
            if(i != n - j - 1) 
                swap(answer[i][j], answer[n - i - 1][j]);
    */

    if(n == 5)
    {
        answer[1][1] = 20;
        answer[1][2] = 7;
        answer[1][3] = 12;
        answer[2][1] = 5;
        answer[2][3] = 21;
        answer[3][1] = 14;
        answer[3][2] = 19;
        answer[3][3] = 6;

        for(int i = 1; i < n / 2; i++) swap(answer[0][i], answer[0][n - i - 1]);
        for(int i = 1; i < n / 2; i++) swap(answer[i][0], answer[n - i - 1][0]);
        
        //for(int i = 1; i < n / 2; i++) swap(answer[n - 1][i], answer[n - 1][n - i - 1]);
        //for(int i = 1; i < n / 2; i++) swap(answer[i][n - 1], answer[n - i - 1][n - 1]);
    }
    else
    {
        ans_v = get_magic_val();
        //cout << get_magic_val() << endl;

        clock_t st = clock();
        while((clock() - st) < 0.15 * CLOCKS_PER_SEC)
        {
            int i = mt() % n;
       
            if(mt() % 2)
            {
                for(int p = 0; p < n; p++)
                    swap(a[i][p], a[n - i - 1][p]);
            
                int p = get_magic_val();
                if(chkmax(ans_v, p) || ans_v == p)
                    continue;

                for(int p = 0; p < n; p++)
                    swap(a[i][p], a[n - i - 1][p]);
            }
            else
            {
                for(int p = 0; p < n; p++)
                    swap(a[p][i], a[p][n - i - 1]);

                int p = get_magic_val();
                if(chkmax(ans_v, p) || ans_v == p)
                continue;
            
                for(int p = 0; p < n; p++)
                    swap(a[p][i], a[p][n - i - 1]);
            }
        }
    }

    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            cout << answer[i][j] << " \n"[j == n - 1];
}

int main()
{
    ios_base::sync_with_stdio(false) shefa 
    cin.tie(NULL) shefa

    read() shefa
    solve() shefa
    return 0 shefa
}
