#include<bits/stdc++.h>
using namespace std;
const int nmax=1e5+42;
int n,q;
vector<int> adj[nmax];
void cut(int node)
{
    for(int i=1;i<=n;i++)
    {
        bool go=0;
        for(auto k:adj[i])
            if(k==node)go=1;
        if(go==0)continue;
        vector<int> help={};
        for(auto k:adj[i])
            if(k!=node)help.push_back(k);
        adj[i]=help;
        break;
    }
}
int height[nmax],parent[nmax];

int in[nmax],out[nmax];
int T=0;
int order[nmax];

void dfs(int node,int h)
{
    T++;
    in[node]=T;
    order[T]=node;
    //cout<<node<<" "<<h<<endl;
    height[node]=h;
    for(auto k:adj[node])
    {
        parent[k]=node;
        dfs(k,h+1);
    }
    out[node]=T;
}

bool start[nmax];
int root;
int lca(int x,int y)
{
    while(height[x]<height[y])y=parent[y];
    while(height[x]>height[y])x=parent[x];

    while(x!=y)
    {
        x=parent[x];
        y=parent[y];
    }
    return x;
}
void small()
{
    dfs(root,0);
    int t,x,y;
    for(int i=1;i<=q;i++)
    {
        cin>>t>>y>>x;
        if(t==2)cout<<lca(x,y)<<endl;
        else
        {
            cut(y);
            adj[x].push_back(y);
            dfs(x,height[x]);
        }
    }
    exit(0);
}
int up[nmax][20];
int lca_fast(int a,int b)
{
    if(height[a]<height[b])swap(a,b);
    for(int i=19;i>=0;i--)
        if(height[a]-(1<<i)>=height[b])a=up[a][i];

    if(a==b)return a;
    for(int i=19;i>=0;i--)
        if(up[a][i]!=up[b][i])a=up[a][i],b=up[b][i];
    return up[a][0];
}
int tree[nmax*4];
void push(int node)
{
    if(tree[node])
    {
        tree[node*2]=tree[node];
        tree[node*2+1]=tree[node];
        tree[node]=0;
    }
}
void update(int node,int l,int r,int lq,int rq,int now)
{
    if(l==lq&&r==rq)
    {
        tree[node]=now;
        return;
    }
    push(node);
    int av=(l+r)/2;
    if(lq<=av)update(node*2,l,av,lq,min(av,rq),now);
    if(av<rq)update(node*2+1,av+1,r,max(av+1,lq),rq,now);
}
int query(int node,int l,int r,int pos)
{
    if(l==r)return tree[node];
    push(node);
    int av=(l+r)/2;
    if(pos<=av)return query(node*2,l,av,pos);
    if(av<pos)return query(node*2+1,av+1,r,pos);
}
int main()
{
cin>>n;
    int x,y;
    for(int i=1;i<n;i++)
    {
    cin>>x>>y;
    adj[x].push_back(y);
    start[y]=1;
    }
    cin>>q;
    for(int i=1;i<=n;i++)
        if(start[i]==0)root=i;

if(n<=10000&&q<=10000)small();

parent[1]=1;

dfs(root,0);
for(int i=1;i<=n;i++)
    up[i][0]=parent[i];

for(int j=1;j<20;j++)
    for(int i=1;i<=n;i++)
    up[i][j]=up[up[i][j-1]][j-1];

for(int i=1;i<=n;i++)
    update(1,1,n,i,i,order[i]);

int t;
for(int i=1;i<=q;i++)
{
    cin>>t>>y>>x;
    if(t==2)
    {
        int actual_x=query(1,1,n,in[x]);
        int actual_y=query(1,1,n,in[y]);
        //cout<<"? "<<actual_x<<" "<<actual_y<<endl;
        if(actual_x==actual_y)
        {
            cout<<lca_fast(x,y)<<endl;
            continue;
        }
        else
        {
            cout<<lca_fast(actual_x,actual_y)<<endl;
        }
    }
    else
    {
        update(1,1,n,in[y],out[y],y);
        parent[y]=x;
        up[y][j]=x;
        for(int j=1;j<20;j++)
            up[y][j]=up[up[y][j-1][j-1];
    }
}
return 0;
}
/*
5
1 2
1 3
2 4
2 5
8
2 4 3
2 5 5
2 1 2
1 2 3
2 4 3
2 4 5
1 4 3
2 4 5

5
1 2
1 3
2 4
2 5
3
1 2 3
2 4 5
2 2 3

*/
