#include <bits/stdc++.h>
using namespace std;
int n, q, par [100005];
void solve1 (){
	for (int i = 1; i < n; i ++){
		int x, y;
		cin >> x >> y;
		par [y] = x;
	}

	cin >> q;
	for (int i = 0; i < q; i ++){
		int t;
		cin >> t;
		if (t == 1){
			int x, y;
			cin >> y >> x;
			par [y] = x;
		}
		if (t == 2){
			int x, y;
			cin >> x >> y;
			if (x == y){
				cout << x << '\n';
				continue;
			}
			stack <int> X, Y;
			int j = x;
			while (j != 0){
				X.push (j);
				j = par [j];
			}
			j = y;
			while (j != 0){
				Y.push (j);
				j = par [j];
			}
			while (1){
				j = X.top ();
				X.pop (); Y.pop ();
				if (X.empty () || Y.empty () || X.top ()!= Y.top ()){
					cout << j << '\n';
					break;
				}
			}
		}
	}
}
vector <int> g [100005];
int heavy [100005];
bool dali [100005];
bool used [100005];
int chain [100005];
int sorted [100005], br = 1, Pos [100005];
int dfs1 (int a){
	if (dali [a]) chain [a] = chain [par [a]];
	else chain [a] = a;
	used [a] = 1;
	int maxsz = 0, maxi = 0;
	for (int i : g [a]){
		if (used [i]) continue;
		int x = dfs1 (i);
		if (x > maxsz){
			maxsz = x;
			maxi = i;
		}
	}
	heavy [a] = maxi;
	dali [maxi] = a;
}
void dfs2 (int a){
	if (a == 0) return;
	used [a] = 1;
	sorted [br] = a;
	Pos [a] = br++;
	dfs2 (heavy [a]);
	for (int i : g [a]){
		if (used [i]) continue;
		dfs2 (i);
	}
}
pair <int, int> tree [400005];
void upd (int l, int r, int pos, int x, int val){
	if (l == r){
		tree [l] = {sorted [x], val};
		return;
	}
	int mid = (l + r) >> 1;
	if (x <= mid) upd (l, mid, pos << 1, x, val);
	else upd (mid + 1, r, (pos << 1) + 1, x, val);
	if (tree [(pos << 1) + 1] == make_pair (-1, -1)) tree [pos] = tree [pos << 1];
	else tree [pos] = tree [(pos << 1) + 1];
}
pair <int, int> query (int l, int r, int pos, int ql, int qr){
	if (l >= ql && r <= qr) return tree [pos];
	if (l > qr || r < ql) return make_pair (-1, -1);
	int mid = (l + r) >> 1;
	auto q1 = query (l, mid, pos << 1, ql, qr), q2 = query (mid + 1, r, (pos << 1) + 1, ql, qr);
	if (q2 == make_pair (-1, -1)) return q1;
	else return q2;
}
pair <int, int> search (int a){
	while (a > 1){
		int b = chain [a];
		pair <int, int> x = query (1, n, 1, Pos [b], Pos [a]);
		if (x != make_pair (-1, -1)) return x;
		a = par [b];
	}
}
int parx [100005][20];
int lca (int x, int y){
	int k = 19;
	while (k >= 0){
		if (parx [x][k] == parx [y][k]) k --;
		else{
			x = parx [x][k];
			y = parx [y][k];
			k --;
		}
	}
	return x;
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (0);
	cout.tie (0);

	cin >> n;

	if (n <= 10000){
		solve1 ();
		return 0;
	}

	for (int i = 1; i < n; i ++){
		int x, y;
		cin >> x >> y;
		g [x].push_back (y);
		par [y] =x;
		parx [y][0] = x;
	}
	parx [1][0] = 1;

	for (int i = 1; i < 20; i ++){
		for (int j = 1; j <= n; j ++){
			if (parx [j][i - 1] == 1) parx [j][i] = 1;
			else parx [j][i] = parx [parx [j][i - 1]][i -1];
		}
	}

	dfs1 (1);
	for (int i = 1; i <= n; i ++) used [i] = 0;
	dfs2 (1);

	for (int i = 1; i < 400002; i ++) tree [i] = {-1, -1};

	cin >> q;
	for (int i = 0; i < q; i ++){
		int t, x, y;
		cin >> t;
		if (t == 1){
			cin >> y >> x;
			upd (1, n, 1, Pos [y], x);
		}
		if (t == 2){
			cin >> x >> y;
			while (1){
				auto x1 = search (x), y1 = search (y);
				if (x1.first == y1.first){
					cout << lca (x, y) << '\n';
					break;
				}
				if (x1.second != -1)x = x1.second;
				if (y1.second != -1)y = y1.second;
			}
		}
	}

	return 0;
}
