#include <bits/stdc++.h>
using namespace std;
int n, m;
struct edge{
	int u, v;
	long long t;
};
edge e [20004];
int l [20004], r [20004];
bool used [20004];
vector <int> g [20004];
long long br;
queue <int> q;
void bfs (int i){
	q.push (i);
	used [i] = 0;
	while (!q.empty ()){
		i = q.front ();
		q.pop ();
		for (int j : g [i]){
			if (used [j]){
				used [j] = 0;
				br --;
				q.push (j);
			}
		}
	}
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (nullptr);
	cout.tie (nullptr);
	
	cin >> n >> m;
	for (int i = 1; i <= m; i ++){
		cin >> e [i].u >> e [i].v >> e [i].t;
	}
	stack <int> s;
	s.push (1);
	l [1] = 0;
	for (int i = 2; i <= m; i ++){
		while (!s.empty () && e [s.top ()].t < e [i].t){
			r [s.top ()] = i;
			s.pop ();
		}
		if (s.empty ()) l [i] = 0;
		else l [i] = s.top ();
		s.push (i);
	}
	while (!s.empty ()){
		r [s.top ()] = m + 1;
		s.pop ();
	}

	vector <int> v;
	long long ans = 500000000000000000;
	for (int i = 1; i <= m; i ++){
		for (int j = l [i] + 1; j < r [i]; j ++){
			int U = e [j].u, V = e [j].v;
			if (!used [U]){
				used [U] = 1;
				v.push_back (U);
			}
			if (!used [V]){
				used [V] = 1;
				v.push_back (V);
			}
			g [U].push_back (V);
			g [V].push_back (U);
		}
		br = n;
		for (int j : v){
			if (used [j]) bfs (j);
			used [j] = 0;
			g [j].clear ();
		}
		v.clear ();
		ans = min (ans, e [i].t * br);
	}
	cout << ans << '\n';

	return 0;
}
