#include<iostream>
#include<set>
using namespace std;
int n, q;
const int maxn = 1e5;
const int maxq = 1e5;
int par[maxn];
int l[maxn];

bool moved[maxn];
int bp[maxn];

set<int> ch[maxn];
struct quer
{
    int x, y, t;
} qs[maxq];

void init_l(int ind)
{
    if(moved[ind])
    {
        //cout << ">>>" << ind + 1 << " " << bp[ind] + 1 << endl;
        bp[ind] = ind;
        //cout << "???" << ind + 1 << " " << bp[ind] + 1 << endl;
    }
    for(int i: ch[ind])
    {
        l[i] = l[ind] + 1;
        bp[i] = bp[ind];
        //cout << "!!!" << i + 1 << " " << bp[i] + 1 << endl;
        init_l(i);
    }
}

void fix(int ind, int f)
{
    l[ind] += f;
    for(int i: ch[ind])
    {
        fix(i, f);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n - 1; i ++)
    {
        int x, y;
        cin >> x >> y;
        x--;y--;
        par[y] = x;
        ch[x].insert(y);
    }

    cin >> q;

    for(int i = 0; i < q; i ++)
    {
        cin >> qs[i].t >> qs[i].x >> qs[i].y;
        qs[i].x--;
        qs[i].y--;
        if(qs[i].t == 1)
        {
            moved[qs[i].x] = true;
        }
    }

    init_l(0);

    /*for(int i = 0; i < n; i ++)
    {
        cout << moved[i] << " " << i + 1 << " - " << bp[i] + 1 << endl;
    }*/

    for(int i = 0; i < q; i ++)
    {
        int x = qs[i].x;
        int y = qs[i].y;
        int t = qs[i].t;
        if(t == 1)
        {
            ch[par[x]].erase(x);
            ch[y].insert(x);
            par[x] = y;
            fix(x, l[y] + 1 - l[x]);
        } else {
            while(bp[bp[x]] != bp[bp[y]])
            {
                if(l[x] > l[y])
                {
                    if(bp[x] != x) x = bp[x];
                    else    x = par[x];
                } else {
                    if(bp[y] != y) y = bp[y];
                    else    y = par[y];
                }
            }
            while(x != y)
            {
                //cout << "HI" << x + 1 << " " << y + 1 << endl;
                if(l[x] > l[y])
                {
                    x = par[x];
                } else {
                    y = par[y];
                }
            }
            cout << x + 1 << "\n";
        }
    }
}
/**
5
1 2
1 3
2 4
2 5
8
2 4 3
2 5 5
2 1 2
1 2 3
2 4 3
2 4 5
1 4 3
2 4 5
*/
