#include<iostream>
#include<unordered_set>
using namespace std;
int n, q;
const int maxn = 1e5;
const int maxq = 1e5;
int par[maxn];
int l[maxn];

bool moved[maxn];
int bp[maxn];
int bpd[maxn];

unordered_set<int> ch[maxn];
struct quer
{
    int x, y, t;
} qs[maxq];

void init_l(int ind)
{
    if(moved[ind])
    {
        bp[ind] = ind;
        bpd[ind] = 0;
    }
    for(int i: ch[ind])
    {
        l[i] = l[ind] + 1;
        bp[i] = bp[ind];
        bpd[i] = bpd[ind] + 1;
        init_l(i);
    }
}

void update_l_f(int i)
{
    if(l[i] == 0)   return;
    int p = bp[i];
    int add = bpd[i];
    if(p == i)
    {
        p = par[i];
        add = 1;
    }
    update_l_f(p);
    l[i] = l[p] + add;
}
void update_l_s(int i)
{
    if(l[i] == 0)   return;
    update_l_s(par[i]);
    l[i] = l[par[i]] + 1;
}

void fix(int ind, int f)
{
    l[ind] += f;
    for(int i: ch[ind])
    {
        fix(i, f);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n - 1; i ++)
    {
        int x, y;
        cin >> x >> y;
        x--;y--;
        par[y] = x;
        ch[x].insert(y);
    }

    cin >> q;

    for(int i = 0; i < q; i ++)
    {
        cin >> qs[i].t >> qs[i].x >> qs[i].y;
        qs[i].x--;
        qs[i].y--;
        if(qs[i].t == 1)
        {
            moved[qs[i].x] = true;
        }
    }

    init_l(0);

    /*for(int i = 0; i < n; i ++)
    {
        cout << moved[i] << " " << i + 1 << " - " << bp[i] + 1 << endl;
    }*/

    for(int i = 0; i < q; i ++)
    {
        int x = qs[i].x;
        int y = qs[i].y;
        int t = qs[i].t;
        if(t == 1)
        {
            ch[par[x]].erase(x);
            ch[y].insert(x);
            par[x] = y;
            //fix(x, l[y] + 1 - l[x]);
        } else {
            update_l_f(x);
            update_l_f(y);
            while(bp[x] != bp[y])
            {
                if(l[bp[x]] > l[bp[y]])
                {
                    if(bp[x] != x)
                    {
                        //cout << "HI";
                        x = bp[x];
                    }
                    else    x = par[x];
                } else {
                    if(bp[y] != y)
                    {
                        //cout << "HI";
                        y = bp[y];
                    }
                    else    y = par[y];
                }
            }
            update_l_s(x);
            update_l_s(y);
            while(x != y)
            {
                //cout << "HI" << x + 1 << " " << y + 1 << endl;
                if(l[x] > l[y])
                {
                    x = par[x];
                } else {
                    y = par[y];
                }
            }
            cout << x + 1 << "\n";
        }
    }
}
/**
5
1 2
1 3
2 4
2 5
8
2 4 3
2 5 5
2 1 2
1 2 3
2 4 3
2 4 5
1 4 3
2 4 5
*/
