#include<iostream>
using namespace std;

long long n, m;
const long long maxn = 200000;
const long long maxm = 200000;
pair<pair<long long,long long> , long long> ro[maxm];

long long par[maxn];
long long sz[maxn];


long long fnd(long long ind)
{
    if(par[ind] == par[par[ind]]) return par[ind];
    par[ind] = fnd(par[ind]);
    return par[ind];
}
void uni(long long a, long long b)
{
    long long a1 = fnd(a);
    long long b1 = fnd(b);
    if(sz[a1] < sz[b1]) swap(a1, b1);
    sz[a1] += sz[b1];
    par[b1] = a1;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(long long i = 0; i < m; i ++)
    {
        long long u, v, t;
        cin >> u >> v >> t;
        u --; v --;
        ro[i] = {{u,v},t};
    }
    //cout << endl;
    long long ans = -1;
    for(long long i = 0; i < m; i ++)
    {
        for(long long j = 0; j < n; j ++)
        {
            par[j] = j;
            sz[maxn] = 1;
        }
        long long comp = n;
        long long maxt = 1;
        for(long long j = i; j < m; j ++)
        {
            if(fnd(ro[j].first.first) != fnd(ro[j].first.second))
            {
                comp --;
                uni(ro[j].first.first, ro[j].first.second);
            }
            maxt = max(maxt, ro[j].second);
            if(ans == -1 || maxt * comp < ans)
            {
                ans = maxt * comp;
            }
            //cout << i << " " << j << " " << maxt*comp << endl;
        }
    }
    cout << ans;
}
/**
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
*/
