#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 500003
#define INF 1000000000000000000
using namespace std;
mt19937 random_generator(237777991);
typedef long long ll;
typedef long double ld;
int n, m;
struct edge
{
    int a, b;
    ll c;
};
edge edges[MAXN];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i++)
        cin >> edges[i].a >> edges[i].b >> edges[i].c;
}
int par[MAXN], sz[MAXN];
int find(int ver)
{
    if (ver == par[ver])
        return ver;
    return par[ver] = find(par[ver]);
}
int components;
void merge(int a, int b)
{
    int root_a = find(a), root_b = find(b);
    if (root_a == root_b)
        return;
    components--;
    if (sz[root_a] < sz[root_b])
        swap(root_a, root_b);
    par[root_b] = root_a;
    sz[root_a] += sz[root_b];
}
pair <ll, int> tr[MAXN << 2];
void merge1(int v)
{
    if (tr[v << 1].first >= tr[(v << 1) + 1].first)
        tr[v] = tr[v << 1];
    else
        tr[v] = tr[(v << 1) + 1];
}
void build(int v, int l, int r)
{
    if (l == r)
    {
        tr[v] = {edges[l].c, l};
        return;
    }
    int mid = (l + r) >> 1;
    build(v << 1, l, mid);
    build((v << 1) + 1, mid + 1, r);
    merge1(v);
}
pair <ll, int> get(int v, int l, int r, int x, int y)
{
    if (l > y || r < x)
        return {-INT_MAX, -1};
    if (l >= x && r <= y)
        return tr[v];
        int mid = (l + r) >> 1;
        auto first = get(v << 1, l, mid, x, y), second = get((v << 1) + 1, mid + 1, r, x, y);
        if (first.first >= second.first)
            return first;
        return second;
}
ll ans = INF;
vector <pair <int, int> > v;
void f(int l, int r)
{
    if (l > r)
        return;
        v.push_back({l, r});
    int pos = get(1, 1, m, l, r).second;
    f(l, pos-1);
    f(pos+1, r);
}
void solve()
{
    build(1, 1, m);
    f(1, m);
    shuffle(v.begin(), v.end(), random_generator);
    int s = v.size();
    for (int i = 0; i < s; i++)
    {
        if ((double)clock() / (double)CLOCKS_PER_SEC > 0.98)
            break;
        for (int j = 1; j <= n; j++)
            par[j] = j, sz[j] = 1;
        components = n;
        for (int j = v[i].first; j <= v[i].second; j++)
            merge(edges[j].a, edges[j].b);
        ans = min(ans, get(1, 1, m, v[i].first, v[i].second).first * components);
    }
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
/*
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
*/
