#include<iostream>
#pragma optimize GCC Ofast
#include<vector>
#include<bitset>
using namespace std;
struct vertex
{
    int par=-1;
    //vector<int> kids;
};
vertex V[100002];
bitset<100002> lc[100002];
int lca(int x,int y)
{
    //lc[456][1233];
    if(x==y)
    {
        return x;
    }
    if(x>y)
    {
        swap(x,y);
    }
    int curr=x;
    while(lc[curr][y]==0)
    {
        curr=V[curr].par;
        if(curr==V[curr].par)
        {
            return curr;
        }
    }
    return curr;
}
bitset<100002> pyramid;
bitset<100002> copy_pyramid;
void dfs(int b)
{
    pyramid[b]=1;
    for(int i=0; i<lc[b].size(); i++)
    {
        if(lc[b][i])
        {
            if(b==i)
            {
                continue;
            }
            dfs(i);
        }
    }
}
int root=-1;
void rem(int b,int x)
{
    //cout<<"Rem"<<b;
    if(b==x)
    {
        return;
    }
    int curr=V[b].par;

    while(x!=curr)
    {
        //cout<<"Rem"<<curr<<"!="<<x;
       /// Sleep(1000);
        lc[curr]=lc[curr]&(pyramid);
        /*if(curr==root)
        {
            return;
        }*/
        curr=V[curr].par;
    }
}
void add(int b,int x)
{
    if(b==x)
    {
        return;
    }
    lc[b]=lc[b]|(copy_pyramid);
    int curr=V[b].par;
    while(x!=curr)
    {
        //cout<<"add"<<curr<<"!="<<x;

        lc[curr]=lc[curr]|(copy_pyramid);
        curr=V[curr].par;
    }
}
void dfss(int curr)
{
   /// cout<<"curr"<<curr<<endl;
    lc[curr].reset();
    lc[curr][curr]=1;
    for(int i=0; i<lc[curr].size(); i++)
    {
        if(lc[curr][i] and i!=curr)
        {

            dfss(i);
            lc[curr]=lc[curr]|lc[i];
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,q;
    cin>>n;
    int u,v;
    for(int i=0; i<n-1; i++)
    {
        cin>>u>>v;
        u--;
        v--;
        lc[u][v]=1;
        V[v].par=u;
    }
    /*cout<<V[0].par<<endl;*/
    for(int i=0; i<n; i++)
    {
        if(V[i].par==-1)
        {
            V[i].par=i;
            root=i;
            break;
        }
    }
    /*cout<<root<<endl;*/
    dfss(root);
    /*for(int j=0; j<n; j++)
    {
        for(int i=0; i<n; i++)
        {
            cout<<lc[j][i];
        }
        cout<<endl;
    }*/
    cin>>q;
    int a,b,c;
    for(int i=0; i<q; i++)
    {
        cin>>a>>b>>c;
        if(a==2)
        {
            b--;
            c--;
            cout<<lca(b,c)+1<<endl;
        }
        else
        {
            b--;
            c--;
           /// cout<<lca(b,c)<<endl;
            pyramid=0;
            dfs(b);
           /* cout<<"P\n";
            for(int i=0;i<n;i++)
            {
                cout<<pyramid[i]<<endl;
            }*/
           /// cout<<"D;";
            copy_pyramid=pyramid;
            pyramid.flip();
           /* for(int j=0; j<n; j++)
            {
                for(int i=0; i<n; i++)
                {
                    cout<<lc[j][i];
                }
                cout<<endl;
            }*/
            rem(b,lca(b,c));
           /* for(int j=0; j<n; j++)
            {
                for(int i=0; i<n; i++)
                {
                    cout<<lc[j][i];
                }
                cout<<endl;
            }*/
           /// cout<<"rm;";
            add(c,lca(b,c));
           /* for(int j=0; j<n; j++)
            {
                for(int i=0; i<n; i++)
                {
                    cout<<lc[j][i];
                }
                cout<<endl;
            }*/
            int x=V[b].par;

            lc[x][b]=0;
            V[b].par=c;
            //cout<<"ad;";
        }
    }
    return 0;
}
