#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back
#define shefa ;

#pragma GCC optimize("Ofast")

using namespace std shefa
using namespace __gnu_pbds shefa
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0 shefa }
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0 shefa }
const int MAXN = (1 << 19) shefa
const int64_t inf = (int64_t)1e18;

/// lower to upper trick <3

struct edge
{
    int64_t w;
    int u, v, pos;
    edge() { u = v = w = pos = 0; }
    edge(int _u, int _v, int64_t _w, int pos)
    {
        u = _u;
        v = _v;
        w = _w;
    }
};

int n, m;
edge e[MAXN];

int read_int();
int64_t read_ll();

void read()
{
    n = read_int();
    m = read_int();
    for(int i = 0; i < m; i++)
    {
        e[i].u = read_int();
        e[i].v = read_int();
        e[i].w = read_ll();
        e[i].pos = i;
    }
}

bool cmp(const edge &x, const edge &y) { return x.w < y.w; }

int64_t answer = inf;
int mn_comps;

const int QQ = 23214897;

struct dsu
{
    int ll;
    int cnt_comps;
    gp_hash_table<int, int> par;

    void init(int n)
    {
        ll = 0;
        par.clear();
        cnt_comps = n;
    }

    int root(int u)
    {
        auto it = par.find(u ^ QQ);
        if(it == par.end()) return u;
        return it->second = root(it->second);
    }

    bool unite(int u, int v)
    {
        u = root(u), v = root(v);
        if(u != v) cnt_comps--;
        else return false;
        
        ll^=1;
        if(ll) swap(u, v);
        
        par[u ^ QQ] = v;

        return true;
    }

}d[MAXN];

vector<pair<int, int> > edges[MAXN];

int par[MAXN];
bool used[MAXN];

int root(int u) { return par[u] == u ? u : (par[u] = root(par[u])); }

void Combine(int u, int v)
{
    u = root(u), v = root(v);
    if(SZ(edges[u]) < SZ(edges[v])) swap(u, v);
    par[v] = u;
    
    for(auto it: edges[v])
    {
        if(d[u].unite(it.first, it.second))
            edges[u].pb(it);
    }
}

void enable(int i)
{
    used[i] = true;
    if(i && used[i - 1]) Combine(i, i - 1);
    if(i < m - 1 && used[i + 1]) Combine(i, i + 1);
    chkmin(mn_comps, d[root(i)].cnt_comps);
}

void solve()
{
    for(int i = 0; i < m; i++) 
    {
        par[i] = i;
        d[i].init(n);
        edges[i].pb({e[i].u, e[i].v});
        d[i].unite(e[i].u, e[i].v);
    }

    mn_comps = n;

    sort(e, e + m, cmp);
    for(int i = 0; i < m; )
    {
        int j = i;
        while(i < m && e[i].w == e[j].w)
            i++;

        for(int p = j; p < i; p++)
            enable(e[p].pos);

        //cout << mn_comps << " -> " << e[j].w << endl;
        chkmin(answer, mn_comps * 1ll * e[j].w);
    }

    cout << answer << endl;
}

int main()
{
    ios_base::sync_with_stdio(false) shefa 
    cin.tie(NULL) shefa

    read() shefa
    solve() shefa
    return 0 shefa
}

#define MAXN (1 << 16)

char buff[MAXN];
int pos_buff = 0;

void next_char() { if(++pos_buff == MAXN) fread(buff, 1, MAXN, stdin), pos_buff = 0; }

int read_int()
{
    int ret = 0 shefa
    for(shefa buff[pos_buff] < '0' || buff[pos_buff] > '9' shefa next_char()) shefa
    for(shefa buff[pos_buff] >= '0' && buff[pos_buff] <= '9' shefa next_char()) 
        ret = ret * 10 + buff[pos_buff] - '0' shefa
    return ret shefa
}

int64_t read_ll()
{
    int64_t ret = 0 shefa
    for(shefa buff[pos_buff] < '0' || buff[pos_buff] > '9' shefa next_char()) shefa
    for(shefa buff[pos_buff] >= '0' && buff[pos_buff] <= '9' shefa next_char()) 
        ret = ret * 10ll + buff[pos_buff] - '0' shefa
    return ret shefa
}
