#include<bits/stdc++.h>
using namespace std;
const int nmax=5e5+42;
int n,m;
struct edge
{
    int u,v;
    long long c;
    int id;
};
edge inp[nmax];
bool cmp(edge a,edge b)
{
    return a.c<b.c;
}

struct comp
{
    unordered_map<int,int> seen;
    int comp;
};
comp work[nmax];
int comps[nmax];
int comps_root(int node)
{
    if(comps[node]==node)return node;
    comps[node]=comps_root(comps[node]);
    return comps[node];
}
int ID;
int root(int node)
{
    if(work[ID].seen.count(node)==0)return node;
    work[ID].seen[node]=root(work[ID].seen[node]);
    return work[ID].seen[node];
}
void my_merge(int id,int u,int v)
{
    //cout<<"my_merge "<<id<<" "<<u<<" "<<v<<endl;
    if(u==v)return;
    ID=id;
    u=root(u);
    v=root(v);
    if(u==v)return;
    work[id].comp--;
    if(rand()%2)work[id].seen[u]=v;
    else work[id].seen[v]=u;
}
bool been[nmax];
int main()
{
scanf("%i%i",&n,&m);
for(int i=1;i<=m;i++)
{
    scanf("%i%i%lld",&inp[i].u,&inp[i].v,&inp[i].c);
    inp[i].id=i;
}
sort(inp+1,inp+m+1,cmp);

for(int i=1;i<=m;i++)work[i].comp=n;
for(int i=1;i<=m;i++)comps[i]=i;

long long ans=1e18;
for(int i=1;i<=m;i++)
{
    //for(int j=1;j<=m;j++)cout<<comps_root(j)<<" ";cout<<endl;
    //cout<<"parent: ";for(int j=1;j<=m;j++)cout<<comps[j]<<" ";cout<<endl;

    int l=(inp[i].id==1?-1:(been[(inp[i].id-1)]==0?-1:comps_root(inp[i].id-1)));
    int r=(inp[i].id==m?-1:(been[(inp[i].id+1)]==0?-1:comps_root(inp[i].id+1)));

    been[inp[i].id]=1;
    //cout<<inp[i].c<<" -> "<<l<<" "<<r<<endl;

    if(l==-1&&r==-1)
    {
        my_merge(inp[i].id,inp[i].u,inp[i].v);
        ans=min(ans,inp[i].c*work[inp[i].id].comp);
    }
    else if(l==-1)//r!=-1
    {
        comps[inp[i].id]=r;
        my_merge(r,inp[i].u,inp[i].v);
        ans=min(ans,inp[i].c*work[r].comp);
    }
    else if(r==-1)//l!=-1
    {
        comps[inp[i].id]=l;
        my_merge(l,inp[i].u,inp[i].v);
        ans=min(ans,inp[i].c*work[l].comp);
    }
    else//l!=-1&&r!=-1
    {
        if(work[l].seen.size()>work[r].seen.size())
        {
            my_merge(l,inp[i].u,inp[i].v);
            for(auto k:work[r].seen)
                my_merge(l,k.first,k.second);
            ans=min(ans,inp[i].c*work[l].comp);
            comps[inp[i].id]=l;
            comps[r]=l;
        }
        else
        {
            my_merge(r,inp[i].u,inp[i].v);
            for(auto k:work[l].seen)
                my_merge(r,k.first,k.second);
            ans=min(ans,inp[i].c*work[r].comp);
            comps[inp[i].id]=r;
            comps[l]=r;
        }
    }
    //cout<<ans<<endl;
}

printf("%lld\n",ans);
return 0;
}
/*
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
*/
