#include <bits/stdc++.h>
#pragma GCC optimize ("O3")
using namespace std;
int n, q, par [100005];
void solve1 (){
	for (int i = 1; i < n; i ++){
		int x, y;
		cin >> x >> y;
		par [y] = x;
	}

	cin >> q;
	for (int i = 0; i < q; i ++){
		int t;
		cin >> t;
		if (t == 1){
			int x, y;
			cin >> y >> x;
			par [y] = x;
		}
		if (t == 2){
			int x, y;
			cin >> x >> y;
			if (x == y){
				cout << x << '\n';
				continue;
			}
			stack <int> X, Y;
			int j = x;
			while (j != 0){
				X.push (j);
				j = par [j];
			}
			j = y;
			while (j != 0){
				Y.push (j);
				j = par [j];
			}
			while (1){
				j = X.top ();
				X.pop (); Y.pop ();
				if (X.empty () || Y.empty () || X.top ()!= Y.top ()){
					cout << j << '\n';
					break;
				}
			}
		}
	}
}
vector <int> g [100005];
int heavy [100005];
bool dali [100005];
bool used [100005];
int chain [100005];
int sorted [100005], br = 1, Pos [100005];
pair <int, int> ans [100005];
int dfs1 (int a){
	if (dali [a]) chain [a] = chain [par [a]];
	else chain [a] = a;
	used [a] = 1;
	int sz = 1;
	int maxsz = 0, maxi = 0;
	for (int i : g [a]){
		if (used [i]) continue;
		int x = dfs1 (i);
		sz += x;
		if (x > maxsz){
			maxsz = x;
			maxi = i;
		}
	}
	heavy [a] = maxi;
	dali [maxi] = a;
	return sz;
}
void dfs2 (int a){
	if (a == 0) return;
	used [a] = 1;
	sorted [br] = a;
	Pos [a] = br++;
	dfs2 (heavy [a]);
	for (int i : g [a]){
		if (used [i]) continue;
		dfs2 (i);
	}
}
pair <int, int> tree [400005];
void upd (int l, int r, int pos, int x, int val){
	if (l == r){
		tree [pos] = {sorted [l], val};
		return;
	}
	int mid = (l + r) >> 1;
	if (x <= mid) upd (l, mid, pos << 1, x, val);
	else upd (mid + 1, r, (pos << 1) + 1, x, val);
	if (tree [(pos << 1) + 1] == make_pair (-1, -1)) tree [pos] = tree [pos << 1];
	else tree [pos] = tree [(pos << 1) + 1];
}
pair <int, int> query (int l, int r, int pos, int ql, int qr){
	if (l >= ql && r <= qr) return tree [pos];
	if (l > qr || r < ql) return make_pair (-1, -1);
	int mid = (l + r) >> 1;
	auto q1 = query (l, mid, pos << 1, ql, qr), q2 = query (mid + 1, r, (pos << 1) + 1, ql, qr);
	if (q2 == make_pair (-1, -1)) return q1;
	else return q2;
}
pair <int, int> search (int a){
	while (a > 1){
		int b = chain [a];
		pair <int, int> x;
		if (heavy [a] == 0) x = ans [b];
		else x = query (1, n, 1, Pos [b], Pos [a]);
		if (x != make_pair (-1, -1)) return x;
		a = par [b];
	}
	return {-1, -1};
}
vector <pair <int, int> > euler;
int euler1 [100005];
void dfs0 (int a, int d){
	euler.push_back ({d, a});
	euler1 [a] = euler.size () - 1;
	for (int i : g [a]){
		dfs0 (i, d + 1);
		euler.push_back ({d, a});
	}
}
pair <int, int> T [1000006];
void build (int l, int r, int pos){
	if (l == r){
		T [pos] = euler [l];
		return;
	}
	int mid = (l + r) >> 1;
	build (l, mid, pos << 1);
	build (mid + 1, r, (pos << 1) + 1);
	T [pos] = min (T [pos << 1], T [(pos << 1) + 1]);
}
pair <int, int> Q (int l, int r, int pos, int ql, int qr){
	if (l >= ql && r <= qr) return T [pos];
	if (l > qr || r < ql) return {n + 5, 0};
	int mid = (l + r) >> 1;
	return min (Q (l, mid, pos << 1, ql, qr), Q (mid + 1, r, (pos << 1) + 1, ql, qr));
}
int lca (int x, int y){
	x = euler1 [x];
	y = euler1 [y];
	if (x > y) swap (x, y);
	return Q (0, euler.size () - 1, 1, x, y).second;
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (nullptr);
	cout.tie (nullptr);

	cin >> n;

	if (n <= 10000){
		solve1 ();
		return 0;
	}

	for (int i = 1; i < n; i ++){
		int x, y;
		cin >> x >> y;
		g [x].push_back (y);
		par [y] =x;
	}

	dfs0 (1, 1);
	build (0, euler.size () - 1, 1);

	dfs1 (1);
	for (int i = 1; i <= n; i ++) used [i] = 0;
	dfs2 (1);

	for (int i = 1; i < 400002; i ++) tree [i] = {-1, -1};
	for (int i = 1; i <= n; i ++){
		ans [i] = {-1, -1};
	}

	cin >> q;
	for (int i = 0; i < q; i ++){
		int t, x, y;
		cin >> t;
		if (t == 1){
			cin >> y >> x;
			upd (1, n, 1, Pos [y], x);
			if (ans [chain [y]] == make_pair (-1, -1)) ans [chain [y]] = {x, y};
			else if (Pos [y] > Pos [ans [chain [y]].second]) ans [chain [y]] = {x, y};
		}
		if (t == 2){
			cin >> x >> y;
			bool dalix = 1, daliy = 1;
			pair <int, int> x1, y1;
			while (1){
				if (dalix) x1 = search (x);
				if (daliy) y1 = search (y);
				if (x1.first == y1.first){
					cout << lca (x, y) << '\n';
					break;
				}
				if (x1.second != -1){x = x1.second;dalix = 0;}
				if (y1.second != -1){daliy = 0;y = y1.second;}
			}
		}
	}

	return 0;
}
