#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 7;

//vector<int> adj[N];
int parent[N];

int used[N];

int find_lca(int x, int y, int idx){
    while(x != 1){
        used[x] = idx;
        x = parent[x];
    }
    used[1] = idx;

    while(used[y] != idx){
        y = parent[y];
    }

    return y;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n, q;

    cin >> n;

    for(int i = 0; i < n - 1; i++){
        int x, y;

        cin >> x >> y;

        parent[y] = x;
    }

    cin >> q;

    for(int i = 0; i < q; i++){
        int type, x, y;

        cin >> type;

        if(type == 1){
            cin >> y >> x;

            parent[y] = x;
        }
        else{
            cin >> x >> y;

            cout << find_lca(x, y, i + 1) << "\n";
        }
    }

    return 0;
}
/*
5
1 2
1 3
2 4
2 5
8
2 4 3
2 5 5
2 1 2
1 2 3
2 4 3
2 4 5
1 4 3
2 4 5
*/
