#include<iostream>
#include<unordered_set>
using namespace std;
int n, q;
const int maxn = 1e5;
int par[maxn];
int l[maxn];
unordered_set<int> ch[maxn];

void init_l(int ind)
{
    if(ind == 0)    return;
    if(l[ind] != 0 && ind != 0)   return;
    init_l(par[ind]);
    l[ind] = l[par[ind]] + 1;
}

void fix(int ind, int f)
{
    l[ind] += f;
    for(int i: ch[ind])
    {
        fix(i, f);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n - 1; i ++)
    {
        int x, y;
        cin >> x >> y;
        x--;y--;
        par[y] = x;
        ch[x].insert(y);
    }
    for(int i = 0; i < n; i ++)
    {
        init_l(i);
        //cout << i + 1 << " = " << l[i] << endl;
    }


    cin >> q;

    for(int i = 0; i < q; i ++)
    {
        int t, x, y;
        cin >> t >> x >> y;
        x--;
        y--;
        if(t == 1)
        {
            ch[par[x]].erase(x);
            ch[y].insert(x);
            par[x] = y;
            fix(x, l[y] + 1 - l[x]);
        } else {
            while(x != y)
            {
                //cout << "HI" << x + 1 << " " << y + 1 << endl;
                if(l[x] > l[y])
                {
                    x = par[x];
                } else {
                    y = par[y];
                }
            }
            cout << x + 1 << "\n";
        }
    }
}
/**
5
1 2
1 3
2 4
2 5
8
2 4 3
2 5 5
2 1 2
1 2 3
2 4 3
2 4 5
1 4 3
2 4 5
*/
