#include<iostream>
#include<stack>
#include<unordered_map>
using namespace std;

int n, m;
const int maxn = 500100;
const int maxm = 500100;
pair<pair<int,int> , long long> ro[maxm];

int par[maxn];
int sz[maxn];

int l[maxn];
int r[maxn];

int check[maxn];


int fnd(int ind)
{
    if(par[ind] == par[par[ind]]) return par[ind];
    par[ind] = fnd(par[ind]);
    return par[ind];
}
void uni(int a, int b)
{
    int a1 = fnd(a);
    int b1 = fnd(b);
    if(sz[a1] < sz[b1]) swap(a1, b1);
    sz[a1] += sz[b1];
    par[b1] = a1;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(int i = 0; i < m; i ++)
    {
        int u, v;
        long long t;
        cin >> u >> v >> t;
        u --; v --;
        ro[i] = {{u,v},t};

        check[i] = -1;
    }

    stack<long long> st;

    for(int i = 0; i < m; i ++)
    {
        while(!st.empty() && ro[i].second > ro[st.top()].second)
        {
            st.pop();
        }
        if(st.empty()) l[i] = -1;
        else    l[i] = st.top();
        st.push(i);
        //cout << l[i] << ": " << ro[i].second << " > " << ro[l[i]].second << endl;
    }
    while(!st.empty())  st.pop();
    //cout << endl;
    for(int i = m - 1; i >= 0; i --)
    {
        while(!st.empty() && ro[i].second > ro[st.top()].second)
        {
            st.pop();
        }
        if(st.empty()) r[i] = m;
        else    r[i] = st.top();
        st.push(i);
        //cout << r[i] << ": " << ro[i].second << " > " << ro[r[i]].second << endl;
    }
    //cout << endl;

    for(int i = 0; i < m; i ++)
    {
        check[l[i] + 1] = max(check[l[i] + 1], r[i] - 1);
    }


    //cout << endl;
    long long ans = -1;

    for(int i = 0; i < m; i ++)
    {
        if(check[i] == -1)   continue;
        for(int j = 0; j < n; j ++)
        {
            par[j] = j;
            sz[j] = 1;
        }
        int comp = n;
        long long maxt = 1;
        for(int j = i; j <= check[i]; j ++)
        {
            if(fnd(ro[j].first.first) != fnd(ro[j].first.second))
            {
                comp --;
                uni(ro[j].first.first, ro[j].first.second);
            }
            maxt = max(maxt, ro[j].second);
            if(ans == -1 || maxt * comp < ans)
            {
                ans = maxt * comp;
            }
            //cout << i << " " << j << " " << maxt*comp << endl;
        }
    }
    cout << ans;
}
/**
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
*/
