#include<iostream>
using namespace std;
int n;
const int maxn = 200;
int ans[maxn][maxn];
int mx;

void print()
{
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < n; j ++)
        {
            cout << ans[i][j] << " ";
        }
        cout << "\n";
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    mx = n * n;
    int x = 0, y = 0;

    int offset = (mx + 1) / 2 - n / 2;
    for(int i = 0; i < mx; i ++)
    {
        if(ans[x][y] != 0)
        {
            x = (x + n - 2) % n;
            y = (y + n - 1) % n;
        }
        ans[x][y] = (i + offset - 1) % mx + 1;
        x ++;
        y ++;
        x %= n;
        y %= n;
    }


    print();
}
