#include<iostream>
using namespace std;

int n, m;
const int maxn = 200000;
const int maxm = 200000;
pair<pair<int,int> , int> ro[maxm];

int par[maxn];
int sz[maxn];


int fnd(int ind)
{
    if(par[ind] == par[par[ind]]) return par[ind];
    par[ind] = fnd(par[ind]);
    return par[ind];
}
void uni(int a, int b)
{
    int a1 = fnd(a);
    int b1 = fnd(b);
    if(sz[a1] < sz[b1]) swap(a1, b1);
    sz[a1] += sz[b1];
    par[b1] = a1;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(int i = 0; i < m; i ++)
    {
        int u, v, t;
        cin >> u >> v >> t;
        u --; v --;
        ro[i] = {{u,v},t};
    }
    int ans = -1;
    for(int i = 0; i < m; i ++)
    {
        for(int j = 0; j < n; j ++)
        {
            par[j] = j;
            sz[maxn] = 1;
        }
        int comp = n;
        int maxt = 0;
        for(int j = i; j < m; j ++)
        {
            if(fnd(ro[j].first.first) != fnd(ro[j].first.second))
            {
                comp --;
                uni(ro[j].first.first, ro[j].first.second);
            }
            maxt = max(maxt, ro[j].second);
            if(ans == -1 || maxt * comp < ans)
            {
                ans = maxt * comp;
                //cout << i << " " << j << " " << ans << endl;
            }
        }
    }
    cout << ans;
}
/**
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
*/
