#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 500003
#define INF 1000000000000000000
using namespace std;
typedef long long ll;
typedef long double ld;
int n, m;
struct edge
{
    int a, b;
    ll c;
};
edge edges[MAXN];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i++)
        cin >> edges[i].a >> edges[i].b >> edges[i].c;
}
int par[MAXN], sz[MAXN];
int find(int ver)
{
    if (ver == par[ver])
        return ver;
    return par[ver] = find(par[ver]);
}
int components;
void merge(int a, int b)
{
    int root_a = find(a), root_b = find(b);
    if (root_a == root_b)
    return;
    components--;
    if (sz[root_a] < sz[root_b])
        swap(root_a, root_b);
    par[root_b] = root_a;
    sz[root_a] += sz[root_b];
    sz[root_b] = 0;
}
void solve()
{
    ll ans = INF;
    for (int i = 1; i <= m; i++)
    {
        for (int j = 1; j <= n; j++)
            par[j] = j, sz[j] = 1;
            components = n;
        for (int j = i; j >= 1; j--)
        {
            if (edges[j].c > edges[i].c)
            break;
            merge(edges[j].a, edges[j].b);
        }
        for (int j = i+1; j <= m; j++)
        {
            if (edges[j].c > edges[i].c)
                break;
            merge(edges[j].a, edges[j].b);
        }
        ans = min(ans, components * edges[i].c);
    }
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
/*
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
*/
