#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 500003
#define INF 1000000000000000000
using namespace std;
typedef long long ll;
typedef long double ld;
ll n, m;
struct edge
{
    ll a, b;
    ll c;
};
edge edges[MAXN];
void read()
{
    cin >> n >> m;
    for (ll i = 1; i <= m; i++)
        cin >> edges[i].a >> edges[i].b >> edges[i].c;
}
ll par[MAXN];
ll find(ll ver)
{
    if (ver == par[ver])
        return ver;
    return find(par[ver]);
}
ll components;
stack <ll> st;
void merge(ll a, ll b)
{
    ll root_a = find(a), root_b = find(b);
    components--;
    par[root_b] = root_a;
    st.push(root_b);
}
pair <ll, ll> tr[MAXN << 2];
void merge(ll v)
{
    if (tr[v << 1].first >= tr[(v << 1) + 1].first)
        tr[v] = tr[v << 1];
    else
        tr[v] = tr[(v << 1) + 1];
}
void build(ll v, ll l, ll r)
{
    if (l == r)
    {
        tr[v] = {edges[l].c, l};
        return;
    }
    ll mid = (l + r) >> 1;
    build(v << 1, l, mid);
    build((v << 1) + 1, mid + 1, r);
    merge(v);
}
pair <ll, ll> get(ll v, ll l, ll r, ll x, ll y)
{
    if (l > y || r < x)
        return {-1, -1};
    if (l >= x && r <= y)
        return tr[v];
        ll mid = (l + r) >> 1;
        auto first = get(v << 1, l, mid, x, y), second = get((v << 1) + 1, mid + 1, r, x, y);
        if (first.first >= second.first)
            return first;
        return second;
}
ll ans = INF;
void f(ll l, ll r, bool keep)
{
    if (l > r)
        return;
    if (l == r)
    {
        if (keep && find(edges[l].a) != find(edges[l].b))
        merge(edges[l].a, edges[l].b);
        ans = min(ans, (n - 1) * edges[l].c);
        return;
    }
    ll pos = get(1, 1, m, l, r).second;
    if (pos - l < r - pos)
    {
        f(l, pos-1, false);
        f(pos + 1, r, true);
        f(l, pos-1, true);
    }
    else
    {
        f(pos+1, r, false);
        f(l, pos-1, true);
        f(pos+1, r, true);
    }
    if (find(edges[pos].a) != find(edges[pos].b))
        merge(edges[pos].a, edges[pos].b);
    ans = min(ans, components * edges[pos].c);
    if (!keep)
        while (!st.empty())
    {
        components++;
        par[st.top()] = st.top();
        st.pop();
    }
}
void solve()
{
    for (int i = 1; i <= n; i++)
        par[i] = i;
    build(1, 1, m);
    components = n;
    f(1, m, true);
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
/*
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
*/
