#include<iostream>
#include<chrono>
#pragma optimize GCC Ofast
#include<vector>
#include<limits>
#include<queue>
#include<set>
#include<random>
#define endl '\n'
#define ull unsigned long long
#define ll long long
using namespace std;
struct rebro
{
    int u,v;
    ll t;
};
struct vruh
{
    bool visited=0;
    vector<int> adj;
};
int n,m;
ull min_res=-1;
vector<rebro> V;
void dfs(vruh vv[],int curr)
{
    vv[curr].visited=1;
    for(int j=0; j<vv[curr].adj.size(); j++)
    {
        if(vv[vv[curr].adj[j]].visited==0)
        {
            dfs(vv,vv[curr].adj[j]);
        }
    }
}
ull calc(int l,int r)/// [l,r];
{
    if(l>r)
    {
        return -1;
    }
    if(l==r)
    {
        if(V[l].u==V[l].v)
        {
            return n*(V[l].t);
        }
        return (n-1)*(V[l].t);
    }
    vruh vv[n+1];
    ll rmq=0;
    for(int o=l; o<=r; o++)
    {
        vv[V[o].u].adj.push_back(V[o].v);
        vv[V[o].v].adj.push_back(V[o].u);
        rmq=max(rmq,V[o].t);
    }
    int res=0;
    for(int i=1; i<=n; i++)
    {
        if(vv[i].visited==0)
        {
            res++;
            dfs(vv,i);
        }
    }
    ///cout<<res<<"R"<<rmq<<endl;
    return res*rmq;
}
int main()
{
     auto start = std::chrono::system_clock::now();
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m;
    /// cout<<min_res<<endl;
    int c1,c2;
    ll c3;
    multiset<pair<ll,int>> st;
    for(int i=0; i<m; i++)
    {
        cin>>c1>>c2>>c3;
        V.push_back({c1,c2,c3});
        st.insert({-c3,i});
    }
    set<int> borders;
    borders.insert(-1);
    borders.insert(m);
    queue<int> curr;
    bool b=true;
    ull op=-1;
    int last=(*st.begin()).first;
    /// cout<<"last="<<last<<endl;
    min_res=calc(0,m-1);
    for(auto it1=st.begin(); it1!=st.end(); it1++)
    {
       /* if(min_res<(-op))
        {
            b=false;
        }*/
        auto endd = std::chrono::system_clock::now();
        std::chrono::duration<double> diff = endd-start;
        if(diff.count()>=0.99)
        {
            cout<<min_res<<endl;
            return 0;
        }
        if((*it1).first==last)
        {
            curr.push((*it1).second);
            borders.insert((*it1).second);
        }
        else
        {
            while(!curr.empty())
            {
                auto x=borders.find(curr.front());
                auto left=*(--x);
                x++;
                x++;
                auto right=*x;
                x--;
                ///cout<<*x<<" "<<left<<" "<<right<<endl;
                if(rand()%11!=0){
                ll r1=calc(left+1,(*x)-1);
                ///cout<<"Q("<<left+1<<","<<(*x)-1<<")="<<r1<<"*"<<-last<<endl;
                if(r1!=-1)
                {
                    min_res=min(min_res,(ull)(r1));
                }
                r1=calc((*x)+1,right-1);
                ///cout<<"Q("<<(*x)+1<<","<<right-1<<")="<<r1<<"*"<<-last<<endl;
                if(r1!=-1)
                {
                    min_res=min(min_res,(ull)(r1));
                }}
                curr.pop();
            }
            /*if(!b)
            {

                cout<<min_res<<endl;
                return 0;
            }*/
            curr.push((*it1).second);
            borders.insert((*it1).second);
            last=(*it1).first;
        }

    }
    while(!curr.empty())
    {
        auto x=borders.find(curr.front());
        auto left=*(--x);
        x++;
        x++;
        auto right=*x;
        x--;
        ///cout<<*x<<" "<<left<<" "<<right<<endl;
        ll r1=calc(left+1,(*x)-1);
        ///cout<<"Q("<<left+1<<","<<(*x)-1<<")="<<r1<<"*"<<-last<<endl;
        if(r1!=-1)
        {
            min_res=min(min_res,(ull)(r1));
        }
        r1=calc((*x)+1,right-1);
        ///cout<<"Q("<<(*x)+1<<","<<right-1<<")="<<r1<<"*"<<-last<<endl;

        if(r1!=-1)
        {
            min_res=min(min_res,(ull)(r1));
        }
        curr.pop();
    }
    cout<<min_res<<endl;
    return 0;
}
