#include <bits/stdc++.h>

#define endl '\n'
#define sz(x) ((int)x.size())
#define all(x) x.begin(), x.end()
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = (int)1e4 + 4;

int n;
int parent[MAXN];

void read() {
    cin >> n;
    parent[1] = -1;
    for (int i = 1; i < n; i++) {
        int x, y;
        cin >> x >> y;
        parent[y] = x;
    }
}

int lca(int u, int v) {
    vector<int> p1, p2;
    int curr = u;
    while (parent[curr] != -1) {
        p1.push_back(curr);
        curr = parent[curr];
    }
    p1.push_back(1);
    curr = v;
    while (parent[curr] != -1) {
        p2.push_back(curr);
        curr = parent[curr];
    }
    p2.push_back(1);
    reverse(all(p1));
    reverse(all(p2));
    int i;
    for (i = 0; i < min(sz(p1), sz(p2)); i++) {
        if (p1[i] != p2[i]) break;
    }
    i--;
    return p1[i];
}

void solve() {
    int q;
    cin >> q;
    for (int i = 1; i <= q; i++) {
        int type, x, y;
        cin >> type >> x >> y;
        if (type == 1) parent[x] = y;
        else cout << lca(x, y) << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}
